
Redmine - Feature #24976

Include new statuses allowed by workflow in Issues REST API

2017-02-02 10:32 - Stephan Möllgaard

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: REST API Estimated time: 0.00 hour

Target version: 5.0.0   

Resolution: Fixed   

Description

Redmine API provide no possibility to get informations about workflows. This feature is important to get informations about next

allowed status for issues.

There a lot of posts from people which need this feature.

Please plan to implement this enhancement for the Redmine API - thank you!

Related issues:

Has duplicate Redmine - Feature #35032: Get allowed Issue statuses by Issues API Closed

Has duplicate Redmine - Feature #10636: get status list for user and current ... Closed

Has duplicate Redmine - Defect #33965: REST API: Method Not Available see use... Closed

Associated revisions

Revision 20951 - 2021-04-19 11:04 - Go MAEDA

Include new statuses allowed by workflow in Issues REST API (#24976).

Patch by Yuichi HARADA.

History

#2 - 2021-04-05 08:03 - Bernhard Rohloff

- Has duplicate Feature #35032: Get allowed Issue statuses by Issues API added

#3 - 2021-04-05 09:42 - Yuichi HARADA

- File status-list.png added

- File 24976.patch added

I would like to add value allowed_statuses to the include parameter.

GET /issues/[id].[format]?include=allowed_statuses

 By specifying this, you can get the available statuses(same values with issue edit form) from the issue's current tracker, issue's current status, and

member's role.
status-list.png 

diff --git a/app/controllers/issues_controller.rb b/app/controllers/issues_controller.rb

index c994862e1..887bcd4bb 100644

--- a/app/controllers/issues_controller.rb

+++ b/app/controllers/issues_controller.rb

@@ -112,6 +112,7 @@ class IssuesController < ApplicationController

         render :template => 'issues/show'

       end

       format.api do

+        @allowed_statuses = @issue.new_statuses_allowed_to(User.current)

         @changesets = @issue.changesets.visible.preload(:repository, :user).to_a

         @changesets.reverse! if User.current.wants_comments_in_reverse_order?

       end

diff --git a/app/views/issues/show.api.rsb b/app/views/issues/show.api.rsb

index f474ed9c6..215184014 100644

--- a/app/views/issues/show.api.rsb
+++ b/app/views/issues/show.api.rsb

@@ -77,4 +77,10 @@ api.issue do

       api.user :id => user.id, :name => user.name

     end

   end if include_in_api_response?('watchers') && User.current.allowed_to?(:view_issue_watchers, @issue.projec

t)

+

+  api.array :allowed_statuses do

+    @allowed_statuses.each do |status|

+      api.status :id => status.id, :name => status.name

+    end

+  end if include_in_api_response?('allowed_statuses')

 end

#4 - 2021-04-08 06:27 - Go MAEDA

- Target version set to Candidate for next major release

Currently, you cannot get the list of new statuses via the API, so many Redmine clients get the list by scraping the HTML of the edit issue page.

#5 - 2021-04-16 05:12 - Go MAEDA

- Subject changed from Redmine API: Support for Workflow to Include new statuses allowed by workflow in Issues REST API

- Target version changed from Candidate for next major release to 5.0.0

Setting the target version to 5.0.0.

#6 - 2021-04-19 11:04 - Go MAEDA

- Status changed from New to Closed

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patch. Thank you for your contribution.

#7 - 2021-06-06 09:54 - Go MAEDA

- Has duplicate Feature #10636: get status list for user and current status added

#8 - 2021-09-09 14:58 - Go MAEDA

- Has duplicate Defect #33965: REST API: Method Not Available see used Status list as per the tracker added

Files

status-list.png 147 KB 2021-04-05 Yuichi HARADA

24976.patch 2.58 KB 2021-04-05 Yuichi HARADA
